/*-
 * Copyright (c) 2005 Norikatsu Shigemura
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: is_enabled_lpw.c,v 1.1 2005/11/13 06:44:26 nork Exp $
 */

#include <sys/param.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dlfcn.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int
main(int argc, char *argv[])
{
	int c, debug = 0;

//	setenv("LD_TRACE_LOADED_OBJECTS", "yes", 1);

	while(  ( c = getopt(argc, argv, "v") ) >= 0  )  {
		switch(  c  )  {
			case 'v':
				debug++;
				break;
		//	default:  NO ACTION
		}
	}
	argc -= optind;
	argv += optind;

	for(  ;  argc > 0;  argc--, argv++  )  {
		pid_t pid;
		char buf1[MAXPATHLEN + 1];
		char buf2[MAXPATHLEN + 1];
		memset(buf1, '\0', sizeof buf1);
		memset(buf2, '\0', sizeof buf2);

		if(  debug  )  printf("*argv=%s\n", *argv);

		if(  readlink(*argv, buf1, sizeof buf1 - 1) <= 0  )  {
			if(  errno == EINVAL  )  {
				strlcpy(buf1, *argv, sizeof buf1);
			}  else  {
				printf("not found\n");
				continue;
			}
		}
		if(  debug  )  printf("buf1=%s\n", buf1);

		if(  realpath(buf1, buf2) == NULL  )  {
			printf("not found\n");
			continue;
		}
		if(  debug  )  printf("buf2=%s\n", buf2);

		if(  debug  )  fflush(stdout);
		if(  (pid = fork()) == 0  )  {		// XXX: not error check:-)
			dlopen(buf2, RTLD_TRACE);
		}  else  {
			int status;
			waitpid(pid, &status, 0);
		}
	}

	return 0;
}
